#' try date and time
#'
#' @import lubridate
#' @importFrom hms as_hms
#'
#' @export
#'
trydatetime <- function(x, modestr = "D", tz = get_tz()) {
    if (modestr == "D") {
        orderstr <- c("ymd", "YmdHMS", "ymdHMS", "ymdHM", "ymdH")
    } else if (modestr == "T") {
        orderstr <- c("HMS", "HM", "H", "YmdHMS", "ymdHMS", "ymdHM", "ymdH", "ymd")
    } else if (modestr == "DT") {
        orderstr <- c("YmdHMS", "ymdHMS", "ymdHM", "ymdH", "ymd")
    } else {
        orderstr <- c("ymd", "YmdHMS", "ymdHMS", "ymdHM", "ymdH")
    }
    if (!lubridate::is.Date(x[1]) & !lubridate::is.timepoint(x[1])) {
        trydate <- lubridate::parse_date_time(x,
                                              orders = orderstr,
                                              tz = tz)
# when we are not treating date, check date
        if (modestr != "T") {
            badind <- lubridate::year(trydate) < 1900 | lubridate::year(trydate) > 2100
            for (i in seq_along(which(badind))) {
                trydate[i] <- lubridate::parse_date_time(paste0(20, x[i]),
                                                      orders = orderstr,
                                                      tz = tz)
            }
        }
    } else {
        trydate <- x
    }
    if (modestr == "D") {
        date <- lubridate::as_date(trydate) # don't use as.Date, it doesn't consider time zone
        return(date)
    }
    if (modestr == "DT") {
        return(trydate)
    }
    if (modestr == "T") {
        return(hms::as_hms(trydate))
    }
}
